@use chrono_humanize::*;
@use crate::AuthorPage;
@use crate::iter::*;
@use crate::limit_description_len;
@use crate::limit_text_len;
@use crate::limit_text_len_mid;
@use crate::templates::author_list_html;
@use crate::templates::base_html;
@use crate::Urler;
@use kitchen_sink::ABlockReason;

@(url: &Urler, p: &AuthorPage<'_>)

@:base_html(&p.page(), {
  <header id="author">
    <div class="inner-col">
    <div class="breadcrumbs">
      <h1><a href="/">Lib.rs</a></h1> › <span class="has-keywords">@if p.is_org() {
        Orgs
      } else {
        Users
      }</span>

      <span class="keywords">
        <span>
          @for key in p.keywords.iter().take(3) {
            <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
          }
        </span>
        @for key in p.keywords.iter().skip(3).take(3) {
          <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
        }
      </span>
    </div>

    <h2>
      @if p.orgs.iter().any(|o| o.login.eq_ignore_ascii_case("rust-lang")) {<span class=labels><span title="Member of the rust-lang org">Rust team</span></span>}
      @p.aut.github.login
    </h2>
    @if let Some(n) = p.name() {
      <p class=desc>@limit_description_len(n, 50, 100, &p.aut.github.login)</p>
    }
    <p>@if let Some(d) = p.joined {
        Joined crates-io @HumanTime::from(d).to_text_en(Accuracy::Rough, Tense::Past).
      }
      @if let Some(d) = p.joined_github() {
        Joined GitHub @HumanTime::from(d).to_text_en(Accuracy::Rough, Tense::Past).
      }
    </p>

    <nav><ul>
      <li><a rel="me ugc nofollow" href="@p.github_url()">GitHub</a></li>
      <li><a rel="ugc nofollow" href="https://crates.io/users/@p.aut.github.login">crates.io</a></li>
      @if !p.must_hide_data {
      @if let Some((url, label)) = p.homepage_link() {
        <li><a href="@url" rel="ugc nofollow" >@limit_text_len(&label, 40, 60)</a></li>
      }
      @if let Some((url, label)) = p.mastodon_link() {
        <li><a href="@url" rel="me ugc nofollow">@limit_text_len_mid(&label, 60)</a></li>
      }
      @if let Some((url, label)) = p.forum_link() {
        <li><a href="@url" rel="ugc nofollow">Forum (@limit_text_len_mid(&label, 60))</a></li>
      }
      @if p.founder_total != 0 || p.member_total != 0 {
        <li><a rel="nofollow" href="@url.crate_maintainer_dashboard_by_github_login(&p.aut.github.login)">Maintainer dashboard</a></li>
      }
      }
    </ul></nav>
    </div>
  </header>
  <main>
    <div class="inner-col">
      @if let Some(reason) = p.blocklist_reason {
        <section>
        @if let ABlockReason::Banned(reason) = reason {
            <h3>⛔️ Flagged user ⛔️</h3>
            <p>Crates of this user have been hidden or downranked on lib.rs. Reason: <i>@reason</i>.</p>
            <p><small>If you're the banned user, you can appeal by opening an issue in <a href="https://gitlab.com/lib.rs/main">the project repo</a>.</small></p>
            <hr>
        }
        @if let ABlockReason::Hidden(reason, url) = reason {
          <aside>
            <h3>This profile page is not available on lib.rs</h3>
            <blockquote>@reason@if let Some(url) = url {<a href="@url">*</a>}</blockquote>
            <hr>
            <p><a href="https://crates.io/users/@p.aut.github.login">See the profile on crates.io</a></p>
          <aside>
        }
        </section>
      }

      @if !p.must_hide_data {
        @if !p.orgs.is_empty() {
          <section>
            <h3>Member of GitHub orgs</h3>
            @for (last, org) in p.orgs.iter().identify_last() {
              <a rel="ugc nofollow" href="@org.html_url">@limit_text_len(AuthorPage::org_name(org), 40, 60)</a>@if !last {,}
            }
          </section>
        }
        @if !p.collab.is_empty() {
          <section>
            <h3>Shares crates with</h3>
            @for (last, (login, on_crate)) in p.collab.iter().identify_last() {
              <a href="@url.crate_owner_by_github_login(login)" title="@on_crate">@limit_text_len(login, 30, 40)</a>@if !last {,}
            }
          </section>
        }
      }
      </div>
      <div class="author-cols">
        <div class="inner-col@if !p.banned { col-container}">
          @if p.founder_total == 0 && p.member_total == 0 {
            <p class=empty>This person doesn't own any crates on crates-io.</p>
          } else if !p.must_hide_data {
            @if p.banned { <details class=reveal><summary>Show the crate@if (p.founder_total + p.member_total) != 1 {s}…</summary><div class=col-container> }
            @if p.founder_total > 0 {
              <section>
                <h3>@limit_text_len(&p.aut.github.login, 15, 40) created @p.founder_total crate@if p.founder_total != 1 {s}</h3>
                @:author_list_html(&p.founder_crates, url)
              </section>
            }
            @if p.member_total > 0 {
              <section>
                <h3>@p.co_owns_label() @p.member_total crate@if p.member_total != 1 {s}</h3>
                @:author_list_html(&p.member_crates, url)
              </section>
            }
            @if p.banned { <div></details> }
          }
        </div>
      </div>
  </main>
  </div>

  <footer>
    <div class="inner-col">
      @if !p.must_hide_data {
        <p>Based on data from crates.io, GitHub, <a href="https://rustaceans.org">rustaceans.org</a>, and other public sources. These pages are automatically generated for crates-io owners, and do not imply endorsement by either the Rust Project nor the users presented here.</p>
      }
      <aside role="contentinfo"><p><a href="/"><b>Lib.rs</b></a> is an unofficial list of Rust/Cargo crates, created by <a href="/~kornelski">kornelski</a>.</p></aside>
    </div>
  </footer>
})
